import { ContextTracker, ExternalTokenizer, LRParser, LocalTokenGroup } from '@lezer/lr';
import { LRLanguage, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const newline = 70, ignoredNewline = 71, Ident = 1, FnIdent = 2, DollarIdent = 3, LBracket = 13, RBracket = 14, LParen = 15, RParen = 16, Comma = 21, LBrace = 51, RBrace = 52;

class MyContext {
    constructor(parent, data) {
        this.parent = parent !== null && parent !== void 0 ? parent : this;
        this.data = data;
    }
    ignoreNewlines(value) {
        return new MyContext(this, Object.assign(Object.assign({}, this.data), { ignoreNewlines: value }));
    }
    justHadComma(value) {
        return new MyContext(this.parent, Object.assign(Object.assign({}, this.data), { justHadComma: value }));
    }
}
const startContext = new MyContext(null, { ignoreNewlines: false, justHadComma: false });
const context = new ContextTracker({
    start: startContext,
    reduce(context, term, stack, input) {
        return context;
    },
    shift(context, term, stack, input) {
        context = context.justHadComma(term === Comma);
        if (term === LParen || term == LBracket) {
            return context.ignoreNewlines(true);
        }
        if (term === LBrace) {
            return context.ignoreNewlines(false);
        }
        if (term === RParen || term == RBrace || term == RBracket) {
            return context.parent;
        }
        return context;
    }
});
function code(x) {
    return x.charCodeAt(0);
}
const newlines = new ExternalTokenizer((input, stack) => {
    let ctx = stack.context.data;
    if (input.next == code("\n")) {
        let ignore = ctx.ignoreNewlines || ctx.justHadComma;
        input.acceptToken(ignore ? ignoredNewline : newline, 1);
        return;
    }
}, { contextual: true });
const identifiers = new ExternalTokenizer((input, stack) => {
    const a = code("a");
    const z = code("z");
    const A = code("A");
    const Z = code("Z");
    const u = code("_");
    const n0 = code("0");
    const n9 = code("9");
    const first = (n) => (a <= n && n <= z) || (A <= n && n <= Z) || (n == u);
    const rest = (n) => first(n) || (n0 <= n && n <= n9);
    let token = Ident;
    if (!first(input.peek(0))) {
        if (input.peek(0) != code("$")) {
            return;
        }
        token = DollarIdent;
    }
    let n = 1;
    while (rest(input.peek(n))) {
        n += 1;
    }
    if (input.peek(n) == code("(")) {
        token = FnIdent;
    }
    input.acceptToken(token, n);
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Ident = {__proto__:null,move:20, and:74, else:76, false:78, if:80, in:82, let:84, match:86, meta:88, not:90, null:92, or:94, this:96, true:98};
const parser = LRParser.deserialize({
  version: 14,
  states: ",SQ`Q!ROOP!QOPOOOOQ!Q'#Dk'#DkO`Q!RO'#D{OOQ!Q'#Cc'#CcO%kQ!RO'#CeO%rQ!RO'#CdO)TQaO'#DiO)]QaO'#DhOOQ`'#D}'#D}O)bQaO'#D{O)pQ!RO'#D{QOQaOOOOQ!Q'#Ce'#CeO%rQ!RO'#D}P*_O!bO'#CaPOOO)C?l)C?lOOQ!Q-E7i-E7iO*gQaO,5:gO)pQ!RO,5:gO*uQ!RO,5:TOOQ!Q'#EP'#EPO+QQ!RO'#D`O+[OQO'#ESO+gOSO'#EVO+oOWO'#EYOOQ!Q'#Df'#DfOOQ!Q'#EO'#EOO/SQ!RO'#EOOOQ!Q'#Dl'#DlO2`Q!RO'#CgOOQ`,59O,59OOOQ!Q'#ER'#ERO%rQ!RO,5:SO3[Q!RO'#DrO*gQaO,5:gO)pQ!RO,5:gOOQ`,5:i,5:iPOOO'#Dj'#DjP3lO!bO,58{POOO,58{,58{O3tQaO1G0RO)pQ!RO1G0RO3tQaO1G0ROOQ!Q'#Dq'#DqO4SQ!RO1G/oO4_Q!RO,59}O4fQ!RO,59}OOQ!Q,59z,59zO4mQaO,5:POOOO'#Dn'#DnO4rOQO,5:nOOQ!Q,5:n,5:nOOOO'#Do'#DoO4}OSO,5:qOOQ!Q,5:q,5:qOOOO'#Dp'#DpO5VOWO,5:tOOQ!Q,5:t,5:tOOQ!Q'#Dm'#DmO5_Q!RO'#DdOOQ!Q'#Dd'#DdOOQ!Q,5:j,5:jOOQ!Q-E7j-E7jOOQ`1G/n1G/nOOQ`,5:^,5:^OOQ`-E7p-E7pPOOO-E7h-E7hPOOO1G.g1G.gO5fQaO7+%mO5fQaO7+%mOOQ!Q-E7o-E7oO5tQ!RO1G/iOOQ!Q1G/i1G/iOOQ!Q1G/k1G/kOOOO-E7l-E7lOOQ!Q1G0Y1G0YOOOO-E7m-E7mOOQ!Q1G0]1G0]OOOO-E7n-E7nOOQ!Q1G0`1G0`OOQ!Q-E7k-E7kOOQ!Q,5:O,5:OO5{QaO<<IXOOQ!Q7+%T7+%T",
  stateData: "6^~O!kOS!iOSSOS!lPQ~OPTOY]OnVOx^Oz^O{^O|VO!QVO!hQO!pSO~O!l_O~OgdOPXXQXXRXXYXX[XX]XX^XX_XX`XXaXXbXXcXXdXXeXXfXXf!]XgXXhXXiXXjXXkXXlXXmXXnXXoXXpXXqXXrXXsXXtXXuXXvXXwXXxXXyXXzXX{XX|XX}XX!OXX!PXX!QXX!RXX!TXX!hXX!pXX!tXX!wXX!zXX!}XX!UXX~O!gXX~P!VOPkOQkORkOYpO[kO]eO^eO_eO`eOaeObeOceOdeOeeOfeOgeOheOieOjeOkeOleOmeOneOoeOpeOqeOreOseOteOupOvpOwpOxpOypOzpO{pO|pO}pO!OpO!PpO!QpO!RpO!TfO!teO!wgO!zhO!}iO!gZP!hZP!pZP!UZP~OgdOf!]X~OfqO~O!hrO!pSO!g!oX!U!oX~OPTOY]OnVOx^Oz^O{^O|VO!QVO!hQO~O!mvO!nxO~O!hrO!pSO!g!oa!U!oa~OP|Og|Of!]a~OP!PO!U!QO~PcO!Z!SO!w!UO!x!SO~O!w!XO!{!VO~O#O!YO#P![O~OPkOQkORkOYpO[kO]eO^eO_eO`eOaeObeOceOdeOeeOfeOgeOheOieOjeOkeOleOmeOneOoeOpeOqeOreOseOteOupOvpOwpOxpOypOzpO{pO|pO}pO!OpO!PpO!QpO!RpO!TfO!h!]O!pSO!teO!wgO!zhO!}iO~O!U!_O~P+wOPkOQkORkOYpO[kO]eO^eO_eO`eOaeObeOceOdeOeeOfeOgeOheOieOjeOkeOleOmeOneOoeOpeOqeOreOseOteOupOvpOwpOxpOypOzpO{pO|pO}pO!OpO!PpO!QpO!RpO!TfO!teO!wgO!zhO!}iO~O!gZX!hZX!pZX!UZX~P/ZOPTOY]OnVOx^Oz^O{^O|VO!QVO~O!g!fX!h!fX!p!fX!U!fX~P2pO!mvO!n!fO~O!hrO!pSO!g!oi!U!oi~OP|Og|Of!]i~OP!jO~PcOi!kO~P!VO!U!lO~O!Z!SO!w!nO!x!SO~O!w!pO!{!VO~O#O!YO#P!rO~O!U!tO~P+wO!hrO!pSO!g!oq!U!oq~Oi!vO~P!VO!hrO!pSO!g!oy!U!oy~OSd~",
  goto: "'i!}PPPPP#OP#R#i#tP$PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP$YPP$b$j$Y$YP#i$m$x%O%b%j%p%v%|&S&YPPPPPPPP&lP&r'V$YP$Y'aPP'aPP'aR`PSZOfScR!O`rYbsy{!g!h!uT!]l!^cXORZcfrtz!OcUORZcfrtz!OQoUQu^R!bq]kU^lnq!^]lU^lnq!^R!`lcWORZcfrtz!OQw_R!ewQROWaRtz!OQtZQzcR!OfUnU^qR!anQ!^lR!s!^Q!TgR!m!TQ!WhR!o!WQ!ZiR!q!ZQ}dR!i}QsYQybW!dsy!h!uQ!h{R!u!gQ[OR!RfSYOfUbRZ!OS{ctQ!crR!gzWmU^nqT!]l!^]jU^lnq!^",
  nodeNames: "⚠ Ident FnIdent DollarIdent LineComment BlockComment Pipeline Pipe OpStmt OpName move Soup Scalar [ ] ( ) + - * / , = . ' : ! ? < > @ % & # ; ^ ` and else false if in let match meta not null or this true EmptyRecord { } RecordStart RecordRest PipeExpr String StringEsc AssignStmt UnExpr",
  maxTerm: 93,
  context: context,
  skippedNodes: [0,4,5,60],
  repeatNodeCount: 9,
  tokenData: "FgnR}OX$OXY%sY[$O[]%s]p$Opq%sqr)_rs)|st*]tu$Ouv*zvw+iwx,Wxy,uyz-dz{.R{|.p|}/_}!O/|!O!P0k!P!Q1Y!Q![5W![!]8u!]!^:V!^!_:t!_!`;c!`!a<Q!a!b<o!b!c=^!c!}$O!}#O={#O#P>j#P#QAQ#Q#RAo#R#S$O#S#TB^#T#f$O#f#gB{#g#o$O#o#pDf#p#qET#q#rEr#r;'S$O;'S;=`Fa<%lO$Ol$XU!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k[$rU!{W!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kW%ZS!{WOr%Us;'S%U;'S;=`%g<%lO%UW%jP;=`<%l%U[%pP;=`<%l$kn&O[!{W#O`!kQ!xSOX$kXY&tY[$k[]&t]p$kpq&tqr$ks#O$k#O#P's#P;'S$k;'S;=`%m<%lO$k^&}[!{W!kQ!xSOX$kXY&tY[$k[]&t]p$kpq&tqr$ks#O$k#O#P's#P;'S$k;'S;=`%m<%lO$kY'xW!{WOY%UYZ(bZ]%U]^(b^r%Us;'S%U;'S;=`%g<%lO%UY(i[!{W!kQOX%UXY(bY[%U[](b]p%Upq(bqr%Us#O%U#O#P's#P;'S%U;'S;=`%g<%lO%Un)jUjQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn*TP!w^#O`st*W`*]O#P`n*hUqQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn+VUoQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn+tUpQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn,cUhQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn-QU_Q!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn-oU`Q!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn.^UcQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn.{UaQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn/jUeQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn0XUbQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn0vUgQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn1eY!{W#O`!xSdQOr$ksz$kz{2T{!P$k!P!Q2p!Q#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^2^U!lQ!{W!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^2yZ!{W!xSSQOY2pYZ$kZ]2p]^$k^r2prs3ls#O2p#O#P4W#P;'S2p;'S;=`5Q<%lO2pQ3qTSQOY3lZ]3l^;'S3l;'S;=`4Q<%lO3lQ4TP;=`<%l3lY4_X!{WSQOY4WYZ%UZ]4W]^%U^r4Wrs3ls;'S4W;'S;=`4z<%lO4WY4}P;=`<%l4W^5TP;=`<%l2pn5c`[Q!{W#O`!xSOr$ks!O$k!O!P6e!P!Q$k!Q![6e![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S6e#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$k^6n`[Q!{W!xSOr$ks!O$k!O!P6e!P!Q$k!Q![6e![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S6e#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$k^7y^[Q!{W!xSOr$ks!Q$k!Q![7p![!c$k!c!}7p!}#O$k#O#P%U#P#R$k#R#S7p#S#T$k#T#o7p#o;'S$k;'S;=`%m<%lO$kn9QWiQ!{W#O`!xSOr$ks![$k![!]9j!]#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$k^9sU!tQ!{W!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn:bUrQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn;PUlQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn;nUfQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn<]UmQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn<zUkQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn=iUnQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn>WU]Q!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kn>qY!{W#O`OY?aYZ?tZ]?a]^?t^r?ars@ss;'S?a;'S;=`@x;=`<%l@s<%lO?a[?hS!ZS!{WOr%Us;'S%U;'S;=`%g<%lO%U^?}[!ZS!{W!kQOX%UXY(bY[%U[](b]p%Upq(bqr%Us#O%U#O#P's#P;'S%U;'S;=`%g<%lO%US@xO!ZS[@}P!ZS;=`<%l?anA]U^Q!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knAzUsQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knBiUtQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knCUW!{W#O`!xSOr$krsCnstCst#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kQCsO!zQ^CzV!{W!xSOr$krsDas#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$kQDfO!}QnDqU!TQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knE`U!pQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$knE}U!UQ!{W#O`!xSOr$ks#O$k#O#P%U#P;'S$k;'S;=`%m<%lO$klFdP;=`<%l$O",
  tokenizers: [1, 2, 3, 4, newlines, identifiers, new LocalTokenGroup("b~RPz{U~XP!P!Q[~aO!n~~", 17, 75)],
  topRules: {"Pipeline":[0,6]},
  dynamicPrecedences: {"53":2,"58":1},
  specialized: [{term: 1, get: value => spec_Ident[value] || -1}],
  tokenPrec: 977
});

const punctuation = `"+" "-" "*" "/" "=" "." "'" ":" "!" "?" "<" ">" "@" "%" "&" "#" ";" "^" "\`"`;
const TenzirQueryLang = LRLanguage.define({
    languageData: {
        commentTokens: { line: "//", block: { open: "/*", close: "*/" } },
    },
    parser: parser.configure({
        props: [
            styleTags({
                "Scalar true false null DollarIdent": tags.literal,
                String: tags.string,
                "StringEsc and else if in let match meta not or this move": tags.keyword,
                "OpName! FnIdent": tags.name,
                [punctuation]: tags.punctuation,
                "LineComment BlockComment": tags.comment,
            }),
        ],
        // TODO: add folding later
    }),
});
function TQL() {
    return new LanguageSupport(TenzirQueryLang);
}

export { TQL, TenzirQueryLang };
